diff --git a/libglusterfs/src/common-utils.c b/libglusterfs/src/common-utils.c
index b325dfbaba0..9f7038763bd 100644
--- a/libglusterfs/src/common-utils.c
+++ b/libglusterfs/src/common-utils.c
@@ -4321,3 +4321,9 @@ gf_unlink(const char *path)
     }
     return _gf_true;
 }
+
+void *
+gf_uuid_dup(uuid_t uuid)
+{
+    return gf_memdup(uuid, sizeof(uuid_t));
+}
diff --git a/libglusterfs/src/glusterfs/common-utils.h b/libglusterfs/src/glusterfs/common-utils.h
index 567e27b19d7..de179373257 100644
--- a/libglusterfs/src/glusterfs/common-utils.h
+++ b/libglusterfs/src/glusterfs/common-utils.h
@@ -1032,6 +1032,8 @@ valid_internet_address(char *address, gf_boolean_t wildcard_acc,
 char *
 gf_rev_dns_lookup(const char *ip);
 
+void *
+gf_uuid_dup(uuid_t uuid);
 char *
 uuid_utoa(uuid_t uuid);
 char *
diff --git a/libglusterfs/src/libglusterfs.sym b/libglusterfs/src/libglusterfs.sym
index 4dc7f2eccc2..4ac13d13b04 100644
--- a/libglusterfs/src/libglusterfs.sym
+++ b/libglusterfs/src/libglusterfs.sym
@@ -712,6 +712,7 @@ gf_uint64_2human_readable
 gf_umount_lazy
 gf_unlink
 gf_update_latency
+gf_uuid_dup
 gf_uuid_clear
 gf_uuid_compare
 gf_uuid_copy
diff --git a/xlators/mgmt/glusterd/src/glusterd-geo-rep.c b/xlators/mgmt/glusterd/src/glusterd-geo-rep.c
index 308a296fd29..b6249575592 100644
--- a/xlators/mgmt/glusterd/src/glusterd-geo-rep.c
+++ b/xlators/mgmt/glusterd/src/glusterd-geo-rep.c
@@ -87,7 +87,7 @@ __glusterd_handle_sys_exec(rpcsvc_request_t *req)
     };
     glusterd_op_t cli_op = GD_OP_SYS_EXEC;
     glusterd_conf_t *priv = NULL;
-    char *host_uuid = NULL;
+    void *host_uuid = NULL;
     char err_str[64] = {
         0,
     };
@@ -128,7 +128,7 @@ __glusterd_handle_sys_exec(rpcsvc_request_t *req)
             dict->extra_stdfree = cli_req.dict.dict_val;
         }
 
-        host_uuid = gf_strdup(uuid_utoa(MY_UUID));
+        host_uuid = gf_uuid_dup(MY_UUID);
         if (host_uuid == NULL) {
             snprintf(err_str, sizeof(err_str),
                      "Failed to get "
@@ -139,7 +139,7 @@ __glusterd_handle_sys_exec(rpcsvc_request_t *req)
             goto out;
         }
 
-        ret = dict_set_dynstr(dict, "host-uuid", host_uuid);
+        ret = dict_set_gfuuid(dict, "host-uuid", host_uuid, false);
         if (ret) {
             gf_smsg(this->name, GF_LOG_ERROR, -ret, GD_MSG_DICT_SET_FAILED,
                     "Key=host-uuid", NULL);
@@ -168,7 +168,7 @@ __glusterd_handle_copy_file(rpcsvc_request_t *req)
     };
     glusterd_op_t cli_op = GD_OP_COPY_FILE;
     glusterd_conf_t *priv = NULL;
-    char *host_uuid = NULL;
+    void *host_uuid = NULL;
     char err_str[64] = {
         0,
     };
@@ -209,7 +209,7 @@ __glusterd_handle_copy_file(rpcsvc_request_t *req)
             dict->extra_stdfree = cli_req.dict.dict_val;
         }
 
-        host_uuid = gf_strdup(uuid_utoa(MY_UUID));
+        host_uuid = gf_uuid_dup(MY_UUID);
         if (host_uuid == NULL) {
             snprintf(err_str, sizeof(err_str),
                      "Failed to get "
@@ -220,7 +220,7 @@ __glusterd_handle_copy_file(rpcsvc_request_t *req)
             goto out;
         }
 
-        ret = dict_set_dynstr(dict, "host-uuid", host_uuid);
+        ret = dict_set_gfuuid(dict, "host-uuid", host_uuid, false);
         if (ret)
             goto out;
     }
@@ -252,7 +252,7 @@ __glusterd_handle_gsync_set(rpcsvc_request_t *req)
     };
     int type = 0;
     glusterd_conf_t *priv = NULL;
-    char *host_uuid = NULL;
+    void *host_uuid = NULL;
     char err_str[64] = {
         0,
     };
@@ -293,7 +293,7 @@ __glusterd_handle_gsync_set(rpcsvc_request_t *req)
             dict->extra_stdfree = cli_req.dict.dict_val;
         }
 
-        host_uuid = gf_strdup(uuid_utoa(MY_UUID));
+        host_uuid = gf_uuid_dup(MY_UUID);
         if (host_uuid == NULL) {
             snprintf(err_str, sizeof(err_str),
                      "Failed to get "
@@ -303,7 +303,7 @@ __glusterd_handle_gsync_set(rpcsvc_request_t *req)
             ret = -1;
             goto out;
         }
-        ret = dict_set_dynstr(dict, "host-uuid", host_uuid);
+        ret = dict_set_gfuuid(dict, "host-uuid", host_uuid, false);
         if (ret)
             goto out;
     }
@@ -2330,7 +2330,7 @@ glusterd_verify_gsync_status_opts(dict_t *dict, char **op_errstr)
 
 int
 glusterd_op_gsync_args_get(dict_t *dict, char **op_errstr, char **primary,
-                           char **secondary, char **host_uuid)
+                           char **secondary, uuid_t *host_uuid)
 {
     int ret = -1;
     xlator_t *this = THIS;
@@ -2359,7 +2359,7 @@ glusterd_op_gsync_args_get(dict_t *dict, char **op_errstr, char **primary,
     }
 
     if (host_uuid) {
-        ret = dict_get_str(dict, "host-uuid", host_uuid);
+        ret = dict_get_gfuuid(dict, "host-uuid", host_uuid);
         if (ret < 0) {
             gf_msg(this->name, GF_LOG_WARNING, 0, GD_MSG_DICT_GET_FAILED,
                    "host_uuid not found");
@@ -2451,8 +2451,7 @@ glusterd_op_stage_copy_file(dict_t *dict, char **op_errstr)
     char abs_filename[PATH_MAX] = "";
     char errmsg[PATH_MAX] = "";
     char *filename = NULL;
-    char *host_uuid = NULL;
-    char uuid_str[64] = {0};
+    uuid_t host_uuid = {0};
     int ret = -1;
     glusterd_conf_t *priv = NULL;
     struct stat stbuf = {
@@ -2489,15 +2488,14 @@ glusterd_op_stage_copy_file(dict_t *dict, char **op_errstr)
         goto out;
     }
 
-    ret = dict_get_str(dict, "host-uuid", &host_uuid);
+    ret = dict_get_gfuuid(dict, "host-uuid", &host_uuid);
     if (ret < 0) {
         gf_msg(this->name, GF_LOG_ERROR, 0, GD_MSG_DICT_GET_FAILED,
                "Unable to fetch host-uuid from dict.");
         goto out;
     }
 
-    uuid_utoa_r(MY_UUID, uuid_str);
-    if (!strcmp(uuid_str, host_uuid)) {
+    if (!gf_uuid_compare(MY_UUID, host_uuid)) {
         ret = dict_get_str(dict, "source", &filename);
         if (ret < 0) {
             gf_msg(this->name, GF_LOG_ERROR, 0, GD_MSG_DICT_GET_FAILED,
@@ -3081,7 +3079,7 @@ glusterd_op_stage_gsync_create(dict_t *dict, char **op_errstr)
     char *down_peerstr = NULL;
     char *secondary = NULL;
     char *volname = NULL;
-    char *host_uuid = NULL;
+    uuid_t host_uuid = {0};
     char *statefile = NULL;
     char *secondary_url = NULL;
     char *secondary_host = NULL;
@@ -3090,7 +3088,6 @@ glusterd_op_stage_gsync_create(dict_t *dict, char **op_errstr)
     char errmsg[PATH_MAX] = "";
     char common_pem_file[PATH_MAX] = "";
     char hook_script[PATH_MAX] = "";
-    char uuid_str[64] = "";
     int ret = -1;
     int is_pem_push = -1;
     int ssh_port = 22;
@@ -3167,8 +3164,7 @@ glusterd_op_stage_gsync_create(dict_t *dict, char **op_errstr)
 
     is_force = dict_get_str_boolean(dict, "force", _gf_false);
 
-    uuid_utoa_r(MY_UUID, uuid_str);
-    if (!strcmp(uuid_str, host_uuid)) {
+    if (!gf_uuid_compare(MY_UUID, host_uuid)) {
         ret = glusterd_are_vol_all_peers_up(volinfo, &conf->peers,
                                             &down_peerstr);
         if ((ret == _gf_false) && !is_force) {
@@ -3586,8 +3582,7 @@ glusterd_op_stage_gsync_set(dict_t *dict, char **op_errstr)
     gf_boolean_t is_running = _gf_false;
     gf_boolean_t is_template_in_use = _gf_false;
     uuid_t uuid = {0};
-    char uuid_str[64] = {0};
-    char *host_uuid = NULL;
+    uuid_t host_uuid = {0};
     xlator_t *this = THIS;
     glusterd_conf_t *conf = NULL;
     struct stat stbuf = {
@@ -3615,8 +3610,6 @@ glusterd_op_stage_gsync_set(dict_t *dict, char **op_errstr)
     if (ret)
         goto out;
 
-    uuid_utoa_r(MY_UUID, uuid_str);
-
     if (conf->op_version < 2) {
         snprintf(errmsg, sizeof(errmsg),
                  "One or more nodes do not"
@@ -3710,7 +3703,7 @@ glusterd_op_stage_gsync_set(dict_t *dict, char **op_errstr)
         ((type == GF_GSYNC_OPTION_TYPE_STOP) && !is_force) ||
         (type == GF_GSYNC_OPTION_TYPE_PAUSE) ||
         (type == GF_GSYNC_OPTION_TYPE_RESUME)) {
-        if (!strcmp(uuid_str, host_uuid)) {
+        if (!gf_uuid_compare(MY_UUID, host_uuid)) {
             ret = glusterd_are_vol_all_peers_up(volinfo, &conf->peers,
                                                 &down_peerstr);
             if (ret == _gf_false) {
@@ -4828,7 +4821,7 @@ glusterd_check_restart_gsync_session(glusterd_volinfo_t *volinfo,
     if (ret == 0) {
         dict_del(volinfo->gsync_active_secondaries, key);
         ret = glusterd_start_gsync(volinfo, secondary, path_list, conf_path,
-                                   uuid_utoa(MY_UUID), NULL, _gf_false);
+                                   NULL, _gf_false);
         if (!ret) {
             /* Add secondary to the dict indicating geo-rep session is
              * running.*/
@@ -5338,8 +5331,7 @@ glusterd_op_copy_file(dict_t *dict, char **op_errstr)
     char abs_filename[PATH_MAX] = "";
     char errmsg[PATH_MAX] = "";
     char *filename = NULL;
-    char *host_uuid = NULL;
-    char uuid_str[64] = {0};
+    uuid_t host_uuid = {0};
     char *contents = NULL;
     char buf[4096] = "";
     int ret = -1;
@@ -5364,7 +5356,7 @@ glusterd_op_copy_file(dict_t *dict, char **op_errstr)
         goto out;
     }
 
-    ret = dict_get_str(dict, "host-uuid", &host_uuid);
+    ret = dict_get_gfuuid(dict, "host-uuid", &host_uuid);
     if (ret < 0)
         goto out;
 
@@ -5382,8 +5374,7 @@ glusterd_op_copy_file(dict_t *dict, char **op_errstr)
         goto out;
     }
 
-    uuid_utoa_r(MY_UUID, uuid_str);
-    if (!strcmp(uuid_str, host_uuid)) {
+    if (!gf_uuid_compare(MY_UUID, host_uuid)) {
         ret = sys_lstat(abs_filename, &stbuf);
         if (ret) {
             len = snprintf(errmsg, sizeof(errmsg),
@@ -5562,7 +5553,6 @@ glusterd_op_gsync_set(dict_t *dict, char **op_errstr, dict_t *rsp_dict)
 {
     int32_t ret = -1;
     int32_t type = -1;
-    char *host_uuid = NULL;
     char *secondary = NULL;
     char *secondary_url = NULL;
     char *secondary_vol = NULL;
@@ -5588,10 +5578,6 @@ glusterd_op_gsync_set(dict_t *dict, char **op_errstr, dict_t *rsp_dict)
     if (ret < 0)
         goto out;
 
-    ret = dict_get_str(dict, "host-uuid", &host_uuid);
-    if (ret < 0)
-        goto out;
-
     if (type == GF_GSYNC_OPTION_TYPE_STATUS) {
         ret = glusterd_get_gsync_status(dict, op_errstr, rsp_dict);
         goto out;
@@ -5701,7 +5687,7 @@ glusterd_op_gsync_set(dict_t *dict, char **op_errstr, dict_t *rsp_dict)
         }
 
         ret = glusterd_start_gsync(volinfo, secondary, path_list, conf_path,
-                                   host_uuid, op_errstr, _gf_false);
+                                   op_errstr, _gf_false);
 
         /* Delete added secondary in the dict if start fails*/
         if (ret)
@@ -6376,8 +6362,7 @@ glusterd_op_gsync_create(dict_t *dict, char **op_errstr, dict_t *rsp_dict)
         0,
     };
     char hooks_args[PATH_MAX] = "";
-    char uuid_str[64] = "";
-    char *host_uuid = NULL;
+    uuid_t host_uuid = {0};
     char *secondary_url = NULL;
     char *secondary_url_buf = NULL;
     char *secondary_user = NULL;
@@ -6487,8 +6472,7 @@ glusterd_op_gsync_create(dict_t *dict, char **op_errstr, dict_t *rsp_dict)
 
     is_force = dict_get_str_boolean(dict, "force", _gf_false);
 
-    uuid_utoa_r(MY_UUID, uuid_str);
-    if (!strcmp(uuid_str, host_uuid)) {
+    if (!gf_uuid_compare(MY_UUID, host_uuid)) {
         ret = dict_get_int32(dict, "push_pem", &is_pem_push);
         if (!ret && is_pem_push) {
             gf_msg_debug(this->name, 0,
@@ -6609,7 +6593,8 @@ glusterd_op_gsync_create(dict_t *dict, char **op_errstr, dict_t *rsp_dict)
         goto out;
 
     ret = glusterd_store_secondary_in_info(
-        volinfo, secondary, host_uuid, secondary_voluuid, op_errstr, is_force);
+        volinfo, secondary, uuid_utoa(host_uuid), secondary_voluuid, op_errstr,
+        is_force);
     if (ret) {
         snprintf(errmsg, sizeof(errmsg),
                  "Unable to store"
diff --git a/xlators/mgmt/glusterd/src/glusterd-snapshot.c b/xlators/mgmt/glusterd/src/glusterd-snapshot.c
index b8c0fb27be2..d698d69425b 100644
--- a/xlators/mgmt/glusterd/src/glusterd-snapshot.c
+++ b/xlators/mgmt/glusterd/src/glusterd-snapshot.c
@@ -8673,7 +8673,7 @@ glusterd_handle_snapshot_fn(rpcsvc_request_t *req)
     glusterd_op_t cli_op = GD_OP_SNAP;
     int type = 0;
     glusterd_conf_t *conf = NULL;
-    char *host_uuid = NULL;
+    void *host_uuid = NULL;
     char err_str[2048] = "";
     xlator_t *this = THIS;
     uint32_t op_errno = 0;
@@ -8709,7 +8709,7 @@ glusterd_handle_snapshot_fn(rpcsvc_request_t *req)
 
         dict->extra_stdfree = cli_req.dict.dict_val;
 
-        host_uuid = gf_strdup(uuid_utoa(MY_UUID));
+        host_uuid = gf_uuid_dup(MY_UUID);
         if (host_uuid == NULL) {
             snprintf(err_str, sizeof(err_str),
                      "Failed to get "
@@ -8717,7 +8717,7 @@ glusterd_handle_snapshot_fn(rpcsvc_request_t *req)
             ret = -1;
             goto out;
         }
-        ret = dict_set_dynstr_sizen(dict, "host-uuid", host_uuid);
+        ret = dict_set_gfuuid(dict, "host-uuid", host_uuid, false);
         if (ret) {
             GF_FREE(host_uuid);
             goto out;
diff --git a/xlators/mgmt/glusterd/src/glusterd-utils.c b/xlators/mgmt/glusterd/src/glusterd-utils.c
index c50c84cf56b..104b0dd0cf3 100644
--- a/xlators/mgmt/glusterd/src/glusterd-utils.c
+++ b/xlators/mgmt/glusterd/src/glusterd-utils.c
@@ -6633,7 +6633,6 @@ _local_gsyncd_start(dict_t *this, char *key, data_t *value, void *data)
     int ret = 0;
     int op_ret = 0;
     int ret_status = 0;
-    char uuid_str[64] = "";
     glusterd_volinfo_t *volinfo = NULL;
     char confpath[PATH_MAX] = "";
     char *op_errstr = NULL;
@@ -6654,8 +6653,6 @@ _local_gsyncd_start(dict_t *this, char *key, data_t *value, void *data)
     else
         return 0;
 
-    (void)snprintf(uuid_str, sizeof(uuid_str), "%s", (char *)value->data);
-
     /* Getting Local Brickpaths */
     ret = glusterd_get_local_brickpaths(volinfo, &path_list);
 
@@ -6748,8 +6745,8 @@ _local_gsyncd_start(dict_t *this, char *key, data_t *value, void *data)
     }
 
     if (is_paused) {
-        glusterd_start_gsync(volinfo, secondary, path_list, confpath, uuid_str,
-                             NULL, _gf_true);
+        glusterd_start_gsync(volinfo, secondary, path_list, confpath, NULL,
+                             _gf_true);
     } else {
         /* Add secondary to the dict indicating geo-rep session is running*/
         ret = dict_set_dynstr_with_alloc(volinfo->gsync_active_secondaries,
@@ -6762,7 +6759,7 @@ _local_gsyncd_start(dict_t *this, char *key, data_t *value, void *data)
             goto out;
         }
         ret = glusterd_start_gsync(volinfo, secondary, path_list, confpath,
-                                   uuid_str, NULL, _gf_false);
+                                   NULL, _gf_false);
         if (ret)
             dict_del(volinfo->gsync_active_secondaries, key1);
     }
@@ -7983,8 +7980,8 @@ glusterd_get_local_brickpaths(glusterd_volinfo_t *volinfo, char **pathlist)
 
 int
 glusterd_start_gsync(glusterd_volinfo_t *primary_vol, char *secondary,
-                     char *path_list, char *conf_path, char *glusterd_uuid_str,
-                     char **op_errstr, gf_boolean_t is_pause)
+                     char *path_list, char *conf_path, char **op_errstr,
+                     gf_boolean_t is_pause)
 {
     int32_t ret = 0;
     int32_t status = 0;
diff --git a/xlators/mgmt/glusterd/src/glusterd-utils.h b/xlators/mgmt/glusterd/src/glusterd-utils.h
index 887bb4e87c9..6689cdf569a 100644
--- a/xlators/mgmt/glusterd/src/glusterd-utils.h
+++ b/xlators/mgmt/glusterd/src/glusterd-utils.h
@@ -331,8 +331,8 @@ glusterd_spawn_daemons(void *opaque);
 
 int
 glusterd_start_gsync(glusterd_volinfo_t *primary_vol, char *secondary,
-                     char *path_list, char *conf_path, char *glusterd_uuid_str,
-                     char **op_errstr, gf_boolean_t is_pause);
+                     char *path_list, char *conf_path, char **op_errstr,
+                     gf_boolean_t is_pause);
 int
 glusterd_get_local_brickpaths(glusterd_volinfo_t *volinfo, char **pathlist);
 
diff --git a/xlators/mgmt/glusterd/src/glusterd.h b/xlators/mgmt/glusterd/src/glusterd.h
index 8ac659090e2..3d147fac078 100644
--- a/xlators/mgmt/glusterd/src/glusterd.h
+++ b/xlators/mgmt/glusterd/src/glusterd.h
@@ -952,7 +952,7 @@ glusterd_op_statedump_volume_args_get(dict_t *dict, char **volname,
 
 int
 glusterd_op_gsync_args_get(dict_t *dict, char **op_errstr, char **primary,
-                           char **secondary, char **host_uuid);
+                           char **secondary, uuid_t *host_uuid);
 
 int
 glusterd_op_get_max_opversion(char **op_errstr, dict_t *rsp_dict);
